## **Foree Check Out**

### Package to use Foree Payment Gateway

## **Usage**

### To use this package in your code:

### First, add a [dependency in your pubspec.yaml file.](https://flutter.dev/docs/development/platform-integration/platform-channels)
        
        dependencies:
            ibad: <latest-version of package>

## **Requirements**
   
    Dart sdk: ">=2.12.0-0 <3.0.0"
    Flutter: ">=1.22.2"
    Android: minSdkVersion 19 and add support for androidx (see AndroidX Migration to migrate an existing app)
    iOS: --ios-language swift, Xcode version >= 12
        
## **add import in your dart code:**

    import 'package:ibad/ibad.dart';


## **Sample Data:**
         
    var data = {
    'key': '<API Key>',
    'amount': '<Amount>',
    'is_generated': <true/false>,
    'reference_number': '<Reference Number>',
    'customer_email_address': '<Customer Email Address>',
    'customer_phone_number': '<Customer Phone Number>',
    'consumer_name': '<Customer Name>'
    }
    
**`is_generated`** takes **`true`** or **`false`** as the possible values. Pass **`true`** in case the bill/invoice is already generated and no new bill/invoice to be made with the given data. **`false`** in case a new bill/invoice is to be created with the given data.

## **Use initiateCheckOut() function of our package(ibad) and pass data.**

    IbadCheckOut.initiateCheckOut(
    Data: data,
    context: context,
    callback: (args) {
    String callbackdata = args.toString();
    var jsondata = jsonDecode(callbackdata);
    print(jsondata);
    });

### In case of payment success or failure, response is received in callback with the data in the following format

```javascript
Success data
{
    bill_status: "paid"
    initiator: "Foree Bill"
    instrument_institution: "ABC Bank"
    instrument_number: "01201234111222"
    instrument_type: "bank_account"
    message: "Your payment has been processed successfully"
    paid_amount: 125.00
    payment_channel: "Internet Banking"
    reference_number: "50"
    status: 1
    transaction_date_time: "2021-01-20 18:32:52"
    transaction_ref_id: "1611149880942"
}
```

```javascript
Failure data
{
    message: "Your payment could not be processed",
    reference_number: "50",
    status: "2"
}
```

