library ibad;

import 'dart:async';
import 'dart:convert';
import 'dart:typed_data';
import 'package:flutter/material.dart';
import 'package:flutter_inappwebview/flutter_inappwebview.dart';

class IbadCheckOut {
  /// used to open the checkout
  static Future initiateCheckOut({
    /// url if any to change pointing
    required String url,

    /// Data Recieved for proceeding payment
    required Map<String, dynamic> data,

    /// Context of your flutter application
    required BuildContext context,

    /// Callback used to send data to flutter application. Can be used to redirect the user too.
    required Function callBack,
  }) async {
    return showDialog(
        context: context,
        builder: (context) {
          return Scaffold(
              body: InAppWebView(
            initialUrlRequest: URLRequest(url: Uri.parse(url)), //working one.
            initialOptions: InAppWebViewGroupOptions(
                crossPlatform: InAppWebViewOptions(
                  useShouldOverrideUrlLoading: true,
                  javaScriptEnabled: true,
                  preferredContentMode: UserPreferredContentMode.DESKTOP,
                ),
                android: AndroidInAppWebViewOptions(
                  useHybridComposition: true,
                )),
                onWebViewCreated: (InAppWebViewController controller) async {
                  if(data['is_generated' == true]){
                    data['is_generated'] = 1;
                  }
                  else{
                    data['is_generated'] = 0;
                  }
                },
            onLoadStop: (controller, url) async {
              String urlParamObj = json.encode(data);
              var postData = Uint8List.fromList(utf8.encode(urlParamObj));
              String encoded = base64Encode(postData);

              controller.evaluateJavascript(
                  source:
                      "const meta = document.createElement('meta'); meta.setAttribute('content', 'width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=0'); meta.setAttribute('name', 'viewport'); document.getElementsByTagName('head')[0].appendChild(meta);");

              controller.evaluateJavascript(
                  source: "initiateCheckout('$encoded')");

              controller.addJavaScriptHandler(
                  handlerName: 'message',
                  callback: (args) {
                    var postMessage = args
                        .toString()
                        .substring(1, args.toString().length - 1);
                    String decoded = utf8.decode(base64.decode(postMessage));
                    var jsonData = json.decode(decoded);
                    callBack(jsonData);
                    Navigator.pop(context);
                  });
            },
          ));
        });
  }
}
